using System;
using System.Reflection;

namespace Microsoft.Samples.BizTalk.Adapters.Wcf.Administration
{
    internal class ConfigObject
    {
        private readonly Type _configType;
        private object _configObject;

        public ConfigObject(object configObject)
        {
            _configObject = configObject;
            _configType = configObject.GetType();
        }

        public object GetPropertyValue(string name)
        {
            PropertyInfo info = _configType.GetProperty(name);
            return info.GetValue(_configObject, null);
        }

        public string GetPropertyValueAsString(string name)
        {
            return (string) GetPropertyValue(name);
        }

        public bool GetPropertyValueAsBoolean(string name)
        {
            return (bool) GetPropertyValue(name);
        }

        public int GetPropertyValueAsInt(string name)
        {
            return (int) GetPropertyValue(name);
        }

        public void SetPropertyValue(string name, object value)
        {
            PropertyInfo info = _configType.GetProperty(name);
            info.SetValue(_configObject, value, null);
        }

        public void SetPropertyValue(string name, Enum value)
        {
            PropertyInfo info = _configType.GetProperty(name);
            info.SetValue(_configObject, value.ToString(), null);
        }
    }
}