namespace Microsoft.Samples.BizTalk.Adapters.Wcf.Administration.Configuration
{
    internal sealed class EndpointConfiguration
    {
        private string _endpointAction;
        private string _endpointUri;
        private string _bindingProfile;
        private string _bindingType;
        private string _bindingConfigurationName;

        private EndpointConfiguration()
        {
        }

        public static EndpointConfiguration Load(ConfigObject configInstance)
        {
            EndpointConfiguration config = new EndpointConfiguration();
            config.EndpointAction = configInstance.GetPropertyValueAsString(ConfigNames.Contract.Action);
            config.EndpointUri = configInstance.GetPropertyValueAsString(ConfigNames.Address.Uri);

            config.BindingProfile = configInstance.GetPropertyValueAsString(ConfigNames.Binding.Profile);
            config.BindingConfigurationName =
                configInstance.GetPropertyValueAsString(ConfigNames.Binding.Configuration);
            config.BindingType = configInstance.GetPropertyValueAsString(ConfigNames.Binding.Type);

            return config;
        }

        public void Save(ConfigObject config)
        {
            config.SetPropertyValue(ConfigNames.Address.Uri, EndpointUri);
            config.SetPropertyValue(ConfigNames.Contract.Action, EndpointAction);
            config.SetPropertyValue(ConfigNames.Binding.Configuration, BindingConfigurationName);
            config.SetPropertyValue(ConfigNames.Binding.Profile, BindingProfile);
            config.SetPropertyValue(ConfigNames.Binding.Type, BindingType);
        }

        public string EndpointAction
        {
            get { return _endpointAction; }
            set { _endpointAction = value; }
        }

        public string EndpointUri
        {
            get { return _endpointUri; }
            set { _endpointUri = value; }
        }

        public string BindingProfile
        {
            get { return _bindingProfile; }
            set { _bindingProfile = value; }
        }

        public string BindingType
        {
            get { return _bindingType; }
            set { _bindingType = value; }
        }

        public string BindingConfigurationName
        {
            get { return _bindingConfigurationName; }
            set { _bindingConfigurationName = value; }
        }


    }
}