using System;
using System.ComponentModel;
using System.Drawing.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using Microsoft.Samples.BizTalk.Adapters.Wcf.Administration.Configuration;

namespace Microsoft.Samples.BizTalk.Adapters.Wcf.Administration
{
    public class BindingConfigEditor : UITypeEditor
    {
        private IWindowsFormsEditorService _editorService = null;

        public BindingConfigEditor()
        {
        }

        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            if (context != null && context.Instance != null)
            {
                return UITypeEditorEditStyle.Modal;
            }
            return base.GetEditStyle(context);
        }

        public override object EditValue(ITypeDescriptorContext context,
                                         IServiceProvider provider,
                                         object value)
        {
            if (null != context && null != context.Instance && null != provider)
            {
                this._editorService = (IWindowsFormsEditorService) provider.GetService
                                          (typeof (IWindowsFormsEditorService));
                if (null != this._editorService)
                {
                    ConfigObject configObject = new ConfigObject(context.Instance);
                    EndpointConfiguration config = EndpointConfiguration.Load(configObject);
                    BindingConfigurationForm bindingConfiguration = new BindingConfigurationForm(config);

                    switch (this._editorService.ShowDialog(bindingConfiguration))
                    {
                        case DialogResult.OK:
                            value = bindingConfiguration.GetValue();
                            config.Save(configObject);
                            break;
                        case DialogResult.Cancel:
                            break;
                    }
                }
            }
            return value;
        }
    }
}