namespace Microsoft.Samples.BizTalk.Adapters.Wcf.Administration
{
    internal class BindingTypeItem
    {
        private readonly string _bindingType;
        private readonly string _friendlyName;

        public BindingTypeItem(string bindingType, string friendlyName)
        {
            _bindingType = bindingType;
            _friendlyName = friendlyName;
        }

        public string BindingType
        {
            get { return _bindingType; }
        }

        public override string ToString()
        {
            return FriendlyName;
        }

        public virtual bool IsUserDefined
        {
            get { return false; }
        }

        public string FriendlyName
        {
            get { return _friendlyName; }
        }
    }

    internal class UserDefinedBindingTypeItem : BindingTypeItem
    {
        public UserDefinedBindingTypeItem()
            : base("{User Defined}", "{User Defined}")
        {
        }

        public override bool IsUserDefined
        {
            get { return true; }
        }

    }
}