using System;
using System.IO;
using Microsoft.Win32;

namespace Microsoft.Samples.BizTalk.Adapters.Wcf.Administration
{
    internal class BizTalkUtility
    {
        private string _bizTalkHostConfigPath;

        public string BizTalkHostConfigPath
        {
            get
            {
                if (_bizTalkHostConfigPath == null)
                    _bizTalkHostConfigPath = GetValidBizTalkConfigPath();
                return _bizTalkHostConfigPath;
            }
        }

        protected string GetValidBizTalkConfigPath()
        {
            string configPath;
            using (RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Microsoft\BizTalk Server\3.0\NTService", false))
            {
                string value = key.GetValue("ExeImagePath") as String;
                if (value == null)
                    return null;

                configPath = value + ".config";
            }

            if (!File.Exists(configPath))
                return null;

            return configPath;
        }

    }
}