﻿using System;
using Microsoft.Samples.BizTalk.Adapters.Wcf.Utility;

namespace Microsoft.Samples.BizTalk.Adapters.Wcf.Configuration
{
    internal sealed class ServiceConfiguration
    {
        private readonly Uri _endpointUri;
        private readonly string _endpointAction;
        private readonly bool _useNativeOneWay;
        private readonly string _bindingConfiguration;
        private readonly Type _bindingType;
        private readonly IdentityType _identityType;
        private readonly string _identityValue;
        private readonly string _behaviorConfiguration;

        private ServiceConfiguration(Uri endpointUri, string endpointAction, bool useNativeOneWay, Type bindingType,
                                     string bindingConfiguration, string behaviorConfiguration,
                                     IdentityType identityType, string identityValue)
        {
            _endpointUri = endpointUri;
            _endpointAction = endpointAction;
            _useNativeOneWay = useNativeOneWay;
            _bindingConfiguration = bindingConfiguration;
            _behaviorConfiguration = behaviorConfiguration;
            _bindingType = bindingType;
            _identityType = identityType;
            _identityValue = identityValue;
        }

        public Uri EndpointUri
        {
            get { return _endpointUri; }
        }

        public string EndpointAction
        {
            get { return _endpointAction; }
        }

        public bool UseNativeOneWay
        {
            get { return _useNativeOneWay; }
        }

        public Type BindingType
        {
            get { return _bindingType; }
        }

        public string BindingConfiguration
        {
            get { return _bindingConfiguration; }
        }

        public IdentityType IdentityType
        {
            get { return _identityType; }
        }

        public string IdentityValue
        {
            get { return _identityValue; }
        }

        public string BehaviorConfiguration
        {
            get { return _behaviorConfiguration; }
        }

        public static ServiceConfiguration CreateFromProperties(WcfAdapterProperties properties)
        {
            return
                new ServiceConfiguration(properties.EndpointUri, properties.EndpointAction, properties.UseNativeOneWay,
                                         properties.BindingType, properties.BindingConfiguration,
                                         properties.BehaviorConfiguration, properties.IdentityType,
                                         properties.IdentityValue);
        }
    }
}