﻿#region Using directives

using System.Diagnostics;
using System.ServiceModel;
using System.ServiceModel.Channels;

#endregion

namespace Microsoft.Samples.BizTalk.Adapters.Wcf.Receiver
{
    [ServiceContract(Name = WcfReceiverSettings.RServiceName,
        Namespace = WcfReceiverSettings.RServiceNamespaceUri)]
    internal interface IIndigoReceiveServiceOneWay
    {
        [OperationContract(Name = WcfReceiverSettings.ROperationName,
            IsOneWay = true,
            Action = WcfReceiverSettings.RequestAction)]
        void Receive(Message msg);
    }

    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
    internal sealed class IndigoReceiveServiceOneWay : IIndigoReceiveServiceOneWay
    {
        private WcfReceiverEndpoint _bizTalkEndpoint;

        public IndigoReceiveServiceOneWay(WcfReceiverEndpoint bizTalkEndpoint)
        {
            _bizTalkEndpoint = bizTalkEndpoint;
        }

        void IIndigoReceiveServiceOneWay.Receive(Message msg)
        {
            Tracer.TraceMessage(TraceLevel.Info, "Indigo Message Recevied");
            _bizTalkEndpoint.ProcessRequestMessage(msg);
        }
    }
}