using System.Xml;
using Microsoft.BizTalk.Component.Interop;
using Microsoft.Samples.BizTalk.Adapter.Common;

namespace Microsoft.Samples.BizTalk.Adapters.Wcf.Transmitter
{
    public sealed class WcfTransmitter : AsyncTransmitter
    {
        public WcfTransmitter()
            : base(WcfTransmitAdapterInfo.Name,
                   WcfAdapterInfo.Version,
                   WcfTransmitAdapterInfo.Description,
                   WcfAdapterInfo.TransportType,
                   WcfTransmitAdapterInfo.Clsid,
                   WcfAdapterInfo.PropertyNamespace,
                   typeof (WcfTransmitterEndpoint), 1)
        {
        }

        protected override void HandlerPropertyBagLoaded()
        {
            IPropertyBag config = HandlerPropertyBag;
            if (null != config)
            {
                XmlDocument handlerConfigDom = ConfigProperties.IfExistsExtractConfigDom(config);
                if (null != handlerConfigDom)
                {
                    WcfTransmitterProperties.HandlerConfiguration(handlerConfigDom);
                }
            }
        }
    }
}